<?php
/* (c) 2002 La Espiral <info@lawebespiral.org>
 * (c) 2002 Vctor P. Arissa <arissa@igijon.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 */

/*
  Dada una palabra de las siglas espiral, con la letra por la cual debe de
  comenzar, la funcion comprueba que dicha palabra se ha pasado correctamente.
  Devuelve 1 si es asi, y cero sino. Ademas, modifica $palabra para formatearla
  correctamente: quitar espacios en blanco, caracteres tontos, ponerla todo en
  minusculas, etc, etc.
  
  IMPORTANTE: saca los mensajes de errores apropiados, por lo que las cabeceras
  HTML ya deben de haber sido enviadas.

  IMPORTANTE: A todas las cadenas PHP ya les ha aplicado la funcion
  addslashes. Si se quiere invertir para sacar por pantallar hay que
  quitar las barras con la funcion stripslashes.
*/
function compruebaletra(&$palabra,$letra)
{
	if(strlen($letra)<1)
	{
	  print('Error interno: No se ha pasado una letra para comparar<br>');
	  return 0;
	}
	elseif(strlen($letra)>1)
	{
	  print('Error interno: No se ha pasado una letra para comparar, sino una palabra completa<br>');
	  return 0;
	}
	$sigla=strtoupper($letra);
	
	if (!$palabra)
	{
	  print("La palabra para la sigla <b>$sigla</b> no se ha definido<br>");
	  return 0;
	}
	// Quitar los espacios en blanco del principio y del final de la cadena
	$palabra=trim($palabra);
	// Convertirlas todas a minusculas
	$palabra=strtolower($palabra);
	
	// La primera letra debe de coincidir con la sigla
	if ($palabra[0]!=$letra)
	{
	  print('La palabra <b>' . stripslashes($palabra) . 
	        "</b> para la sigla <b>$sigla</b> no empieza con esta letra<br>");
	  return 0;
	}
	// Ahora ya podemos poner la primera letra en mayuscula
	$palabra=ucfirst($palabra);
	return 1;
}
/*
   Muestra en HTML las frases propuestas (solo como lectura) o
   las frases actuales. Ambas tablas tienen LA MISMA estructura.
*/
function muestra_frases($tabla,$comentario)
{
 global $db;
 
 $sql='select * from '.$tabla.';';
 $resultfrases=query($sql,$db) or error_sql_traza(__FILE__, __LINE__);
 if(num_rows($resultfrases)==0)
   print('No hay entidades para '.$comentario);
 else
 {
   print('<center><table><caption>'.$comentario.'</caption>');
   print('<tr bgCOLOR="#ECD560"><td>Frase</td><td>Autor</td></tr>');
   while($fila=fetch_array($resultfrases))
   {   
   	print('<tr><td>'.$fila[frase].'</td>');
  	$usuario=sacarInfoUsuario($fila[user_id]);
	if($usuario) print('<td>'.$usuario[username].'</td>');
	else   	     print('<td>annimo</td>');
	print('</tr>');
   }
   print('</table></center>');
   salto(2);
 }	
}
/*
   Muestra en HTML las imagenes propuestas (solo como lectura) y
   las imagenes actuales. Ambas tablas tienen LA MISMA estructura.
*/
function muestra_imagenes($tabla,$directorio,$comentario)
{
 global $db;
 
 $sql='select * from '.$tabla.';';
 $resultfrases=query($sql,$db) or error_sql_traza(__FILE__, __LINE__);
 if(num_rows($resultfrases)==0)
   print('No hay entidades para '.$comentario);
 else
 {
   print('<center><table>');
   print('<tr bgCOLOR="#ECD560"><td>'.$comentario.'</td><td>Frase, autor y fichero</td></tr>');
   while($fila=fetch_array($resultfrases))
   {   
   	// La imagen ocupa 3 filas. Poner la primera celda como imagen y
   	// la segunda con la frase
   	print('<tr><td rowspan="3" align="center"><img src="'. $directorio. $fila[fichero] .
   	      '" alt="'.$fila[frase].'"></td>');
   	print('<td align="center">'.$fila[frase].'</td></tr>');
   	// Segunda fila, la primera celda sigue siendo la imagen (no hace falta ponerla),
   	// La segunda celda (la unica puesta) es el autor
  	$usuario=sacarInfoUsuario($fila[user_id]);
	if($usuario) print('<tr><td align="center">Mandada por: '.$usuario[username].'</td></tr>');
	else   	     print('<tr><td align="center">annimo</td></tr>');
	// Tercera fila, la primera celda sigue siendo la imagen (no hace falta ponerla),
	// la segunda celda (la nica puesta) es el nombre del fichero
	print('<tr><td align="center">Nombre del fichero: '.$fila[fichero].'</td></tr>');
   }
   print('</table></center>');
   salto(2);
 }	
}
/*
  Devuelve la fila asociada a una frase, sacando los mensajes
  HTML apropiados
*/
function devuelve_fila_profrase($idprofrase)
{
 global $db;
 
 if (empty($idprofrase))
   print('Error interno: no se ha pasado el identificador de la frase.<br>');
 else
 {
   $sql='select * from e_gadgets_profrases where idprofrase='.$idprofrase.';';
   $resultfrases=query($sql,$db) or error_sql_traza(__FILE__, __LINE__);

   if (num_rows($resultfrases)==0)
     print('No se ha encontrado la frase especificada entre las propuestas de frases.<br>');
   elseif (num_rows($resultfrases)!=1)
     print('Error interno: ha seleccionado una nica frase, pero el sistema encuentra mas de una con el mismo identificador<br>');
   else
     $fila=fetch_array($resultfrases); // Sabemos que hay una
 }
 return $fila; // Si hubo algun error sera vacia.
}
/*
  Devuelve la fila asociada a una imagen, sacando los mensajes
  HTML apropiados
*/
function devuelve_fila_proimagen($idproimagen)
{
 global $db;
 
 if (empty($idproimagen))
   print('Error interno: no se ha pasado el identificador de la imagen.<br>');
 else
 {
   $sql='select * from e_gadgets_proimagenes where idproimagen='.$idproimagen.';';
   $resultimagenes=query($sql,$db) or error_sql_traza(__FILE__, __LINE__);

   if (num_rows($resultimagenes)==0)
     print('No se ha encontrado la imagen especificada entre las propuestas de imagenes.<br>');
   elseif (num_rows($resultimagenes)!=1)
     print('Error interno: ha seleccionado una nica imagen, pero el sistema encuentra mas de una con el mismo identificador<br>');
   else
     $fila=fetch_array($resultimagenes); // Sabemos que hay una
 }
 return $fila; // Si hubo algun error sera vacia.
}

/*
  PROPUESTA PARA PONER EN INCLUDE/GENERAL
  
  Funcion para renombrar ficheros, sacando mensajes HTML si hay errores
  Devuelve 1 si tuvo exito y 0 sino.
  Comprueba si el fichero existe en el destino.
*/
function renombra($origen,$destino)
{
  if(file_exists($destino))
  {
      print('Ya existe un fichero llamado <b>'.basename($destino).'</b>. '.
            'Por favor, renombre el archivo.<br>');
      return 0;
   }
   // @ es para que no saque el error estandar por pantalla
   $result=@rename($origen,$destino);
   if(!$result)
   {
      print('No se ha podido almacenar el fichero <b>'.basename($destino).'</b>.<br>');
      if ($php_errormsg)
        print('Razn: '.$php_errormsg . '.<br>');
      return 0;
   }
   return 1;
}
/*
  PROPUESTA PARA PONER EN INCLUDE/GENERAL

  Saca un mensaje informativo de por qu no se ha podido mandar un mensaje
  de correo, ms los datos de dicho mensaje.

  Esta funcin quizs podra ir en algn include/general.
*/
function error_email($explicacion,$destinatario,$cabeceras,$asunto,$mensaje,
		     $razonfallo)
{
      global $php_errormsg;
      
      print($explicacion);
      if ($razonfallo)
        print('Razn: '.$razonfallo . '<br>');
      salto();
      print('Destinatario: '.$destinatario.'<br>');
      print('cabeceras: '.$cabeceras.'<br>');
      print('Asunto: '.$asunto.'<br>');
      print('Mensaje:<br><br><I>');
      print(nl2br(htmlspecialchars(stripslashes($mensaje))).'</I><br>'); 
}

function inicializa_semilla_aleatorios()
{
  srand((double)microtime()*1000000);
}

function frase_aleatoria()
{
  global $db;
  $defecto='Experimento Simptico de Poltica Improvisada Radiando Amor y Libertad';
  
  $sql='select * from e_gadgets_frases;';
  
  $result=query($sql,$db);
  if (!$result) return $defecto;
  
  $filas=num_rows($result);
  if($filas<=0) return $defecto;
  else
  {
    $aleatorio=rand(0,$filas-1);
    // Aqu no indicamos el error para no fastidiar la pagina principal
    if (!mysql_data_seek($result,$aleatorio))
      return $defecto;

    $fila=fetch_array($result);
    if(!$fila) return $defecto;
    return stripslashes($fila[frase]);
  }
}
/*
  Devuelve el nombre de la imagen.
  Por referencia, devuelve la frase asociada a
  dicha imagen.
*/
function imagen_aleatoria(&$fraseimagen)
{
  global $db,$dirimgportada;
  $defecto=$imagendefecto;
  $fraseimagen=$fraseimagendefecto;
  
  $sql='select * from e_gadgets_imagenes;';
  
  $result=query($sql,$db);
  if (!$result) return $defecto;
  
  $filas=num_rows($result);
  if($filas<=0) return $defecto;
  else
  {
    $aleatorio=rand(0,$filas-1);
    // Aqu no indicamos el error para no fastidiar la pagina principal
    if (!mysql_data_seek($result,$aleatorio))
      return $defecto;

    $fila=fetch_array($result);
    if(!$fila) return $defecto;
    
    $destino=$dirimgportada . $fila[fichero];
    if(!file_exists($destino)) return $defecto;
    
    $fraseimagen=stripslashes($fila[frase]);
    return $destino;
  }
}
?>