<?php 

/* (c) 2002 La Espiral <info@lawebespiral.org>
 * (c) 2002 Javier Linares <javier@javierlinares.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 */


/*  
 *  Este archivo proporciona funciones genricas para el acceso a la base de
 *  datos SQL. Hay funciones de:
 *
 *  Creacin:
 *	-  crearRegistro($tabla, $campos, $valores);
 *	   devuelve: resultado de la creacin (true/false)
 *
 *  Seleccin:
 *  	- obtieneCampo($campo, $tabla, $condWhere);
 * 	  devuelve: array con el nombre de los campos 
 *		    como ndices
 *
 *  Edicin:
 *	- actualizaCampo($campo, $valor, $tabla, $condWhere); 
 *        devuelve: resultado de la creacin (true/false)
 *
 *  Eliminacin:
 *	- eliminaRegistro($tabla, $condWhere);
 *	  devuelve: resultado de la eliminacin (true/false)
 *
 */



/*  
 * Alias para las funciones de MySQL
 */

function query($sql, $db) {
	return(mysql_query($sql, $db));
}
function fetch_array($result) {
	return(mysql_fetch_array($result));
}
function num_rows($result) {
	return(mysql_num_rows($result));
} 

function error_sql()
{
 printf("%d: %s<BR>", mysql_errno(), mysql_error());
 exit();
}

function error_sql_traza($file, $line)
{
 printf("F:%s(%d) - %d:%s<BR>", $file, $line, mysql_errno(), mysql_error());
 exit();
}

function affected_rows($result) {
 return(mysql_affected_rows($result));
}
function fetch_row($result) {
	return(mysql_fetch_row($result));
}
function fetch_object($result) {
	return(mysql_fetch_object($result));
}
function fetch_lengths($result) {
 return(mysql_fetch_lengths($result));
}
function data_seek($result) {
 return(mysql_data_seek($result));
}
/*
 * Alias para las funciones de postgreSQL
 *
 *
 * function query($sql, $db) {
 *	return(pg_exec($sql, $db);
 * }
 * function fetch_array($result) {
 *	return(pg_fetch_array($result));
 * }
 *
 *
 */


/*  
 * Funciones genricas para acceso a la base de datos SQL 
 */

function crearRegistro($tabla, $campos, $valores) {
	global $db;

	$sql  	= "INSERT INTO $tabla ($campos) VALUES ($valores)"; 
	$result	= query($sql, $db);
	return($result);
}
function obtieneCampo($campo, $tabla, $condWhere) {

	global $db;
	$salida = "";

	$sql 	= "SELECT $campo FROM $tabla WHERE $condWhere";
	$result	= query($sql, $db);
	if($result) {
		$row = fetch_array($result);
		$salida=$row[$campo];
	}
	return($salida);
}
function actualizaCampo($campo, $valor, $tabla, $condWhere) {
	global $db;

	$sql 	= "UPDATE $tabla SET $campo='$valor' WHERE $condWhere";
	$result	= query($sql, $db);
	return($result);
}
function eliminaRegistro($tabla, $condWhere) {
	global $db;

	$sql 	= "DELETE FROM $tabla WHERE $condWhere";
	$result	= query($sql, $db);
	return($result);

}


?>